/*->c.cscurve */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "scanplus.h"




#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "constants.h"



#include "view.h"
#include "file.h"

#include "dbscale.h"

#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "prstr.h"


#include "colsep.h"
#include "colseplink.h"





#include "colsepx.h"
#include "csstr.h"

#include "colcode.h"
#include "csnaive.h"

#include "cscurve.h"





static char cyanc[256];
static char ucrc[256];
static char blackc[256];
static char yellowc[256];
static char magentac[256];

static char cyanc16[32];
static char blackc16[32];
static char yellowc16[32];
static char magentac16[32];
static char ucrc16[32];



#ifdef INVC



static char cyanic[256];
static char blackic[256];
static char yellowic[256];
static char magentaic[256];




static void invertcurve(char * d,char * s)
{
 int i;
 int j;
 int delta;
 int deltan;
 int dx;

 for(i=0;i<256;i++)
 {
  delta=0x200;    /* a big number */
  deltan=0;

  for(j=0;j<256;j++)
  {
   dx=ABS(s[j]-i);
   if(dx<delta) 
   {
    delta=dx;
    deltan=j;
   }
  }

  d[i]=deltan;
 }
}


#endif



static void makecurve16(char * d,char * s)
{
 int i;

 for(i=0;i<32;i++)
 {
  d[i]=s[8*i]/8;
 }
}






void cscurvergb2cmyk(quadstr * rgb,quadstr * cmyk)
{
 int c;
 int m;
 int y;
 int k;

 c=MAXCV-rgb->type.rgb.r;
 m=MAXCV-rgb->type.rgb.g;
 y=MAXCV-rgb->type.rgb.b;

 c=(c*255)/MAXCV;
 m=(m*255)/MAXCV;
 y=(y*255)/MAXCV;

 k=MIN(c,m);
 k=MIN(k,y);

 cmyk->type.cmyk.k=(blackc[k]*MAXCV)/255;
 if(ucrc[k]<k) k=ucrc[k];

 cmyk->type.cmyk.c=(cyanc[c-k]*MAXCV)/255;
 cmyk->type.cmyk.m=(magentac[m-k]*MAXCV)/255;
 cmyk->type.cmyk.y=(yellowc[y-k]*MAXCV)/255;
}






os_error * cscurvecmyk2rgb(quadstr * cmyk,quadstr * rgb)
{

#ifdef INVC

 int c;
 int m;
 int y;
 int k;

 c=(cmyk->type.cmyk.c*255)/MAXCV;
 m=(cmyk->type.cmyk.m*255)/MAXCV;
 y=(cmyk->type.cmyk.y*255)/MAXCV;
 k=(cmyk->type.cmyk.k*255)/MAXCV;

 c=cyanic[c];
 m=magentaic[m];
 y=yellowic[y];
 k=blackic[k];

 k=ucrc[k];

 c+=k;
 m+=k;
 y+=k;

 rgb->type.rgb.r=(MAXCV*(255-c))/255;
 rgb->type.rgb.g=(MAXCV*(255-m))/255;
 rgb->type.rgb.b=(MAXCV*(255-y))/255;

 return(NULL);

#else

 cmyk2rgb(cmyk,rgb);
 return(NULL);

#endif

}




os_error * cscurvecmyk2rgb3232(int * s,int * d,int size)
{

#ifdef INVC

 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;


  c=cyanic[c];
  m=magentaic[m];
  y=yellowic[y];
  k=blackic[k];

  k=ucrc[k];

  c+=k;
  m+=k;
  y+=k;

  r=(255-c);
  if(r<0) r=0;
  else
  if(r>255) r=255;

  g=(255-m);
  if(g<0) g=0;
  else
  if(g>255) g=255;

  b=(255-y);
  if(b<0) b=0;
  else
  if(b>255) b=255;

  *d++=(b<<16)|(g<<8)|r;

 }

 return(NULL); 

#else

return(cscmyk2rgb3232(s,d,size));

#endif
}






os_error * cscurvecmyk2bgr3232(int * s,int * d,int size)
{

#ifdef INVC

 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;


  c=cyanic[c];
  m=magentaic[m];
  y=yellowic[y];
  k=blackic[k];

  k=ucrc[k];

  c+=k;
  m+=k;
  y+=k;

  r=(255-c);
  if(r<0) r=0;
  else
  if(r>255) r=255;

  g=(255-m);
  if(g<0) g=0;
  else
  if(g>255) g=255;

  b=(255-y);
  if(b<0) b=0;
  else
  if(b>255) b=255;

  *d++=(b)|(g<<8)|(r<<16);
 }

 return(NULL); 

#else

return(cscmyk2bgr3232(s,d,size));

#endif
}










os_error * cscurvergb32torgb32(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */

    *d++=0xFFFF00|tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   word=*s++;
   c=0xFF-(word & 0xFF);
   m=0xFF-((word & 0xFF00)>>8);
   y=0xFF-((word & 0xFF0000)>>16);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc[k];

   tint=0xFF-k;     /* black */

   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}



os_error * cscurvebgr32tobgr32(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */

    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *d++=0xFFFF00|(tint);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   word=*s++;
   y=0xFF-(word & 0xFF);
   m=0xFF-((word & 0xFF00)>>8);
   c=0xFF-((word & 0xFF0000)>>16);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc[k];

   tint=0xFF-k;     /* black */

   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}





os_error * cscurvebgr24tobgr24(int * s,int * d,int size,int key,int mask)
{
// int word;
 int tint;
 int c;
 int m;
 int y;
 int k;
 char * sp;
 char * dp;


 sp=(char*)s;
 dp=(char*)d;


 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */
    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(cyanc[c-k]);     /* cyan */

    *dp++=0xFF;
    *dp++=0xFF;
    *dp++=tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(yellowc[y-k]);     /* yellow */

    *dp++=tint;
    *dp++=0xFF;
    *dp++=0xFF;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc[k];

    tint=0xFF-(magentac[m-k]);     /* magenta */

    *dp++=0xFF;
    *dp++=tint;
    *dp++=0xFF;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   y=0xFF-(*sp++);
   m=0xFF-(*sp++);
   c=0xFF-(*sp++);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc[k];

   tint=0xFF-k;     /* black */

   *dp++=tint;
   *dp++=tint;
   *dp++=tint;
  }
 }

 return(NULL);
}







os_error * cscurvergb16torgb16(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int dest;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest=0x7FE0|tint;

    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest|=((0x7FE0|tint)<<16);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest=0x3FF|(tint<<10);

    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest|=0x3FF0000|(tint<<26);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest=0x7C1F|(tint<<5);

    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest|=0x7C1F0000|(tint<<21);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while((size-=2)>-2)
  {
   word=*s++;

   c=0x1F-(word & 0x1F);
   m=0x1F-((word & 0x3E0)>>5);
   y=0x1F-((word & 0x7C00)>>10);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc16[k];

   tint=0x1F-k;     /* black */

   dest=(tint<<10)|(tint<<5)|tint;


   c=0x1F-((word & 0x1F0000)>>16);
   m=0x1F-((word & 0x3E00000)>>21);
   y=0x1F-((word & 0x7C000000)>>26);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc16[k];

   tint=0x1F-k;     /* black */

   dest|=(tint<<26)|(tint<<21)|(tint<<16);

   *d++=dest;
  }
 }

 return(NULL);



}








os_error * cscurvebgr16tobgr16(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int dest;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */

    dest=0x3FF|(tint<<10);

    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(cyanc16[c-k]);     /* cyan */


    dest|=0x3FF0000|(tint<<26);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest=0x7FE0|tint;

    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(yellowc16[y-k]);     /* yellow */

    dest|=((0x7FE0|tint)<<16);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest=0x7C1F|(tint<<5);

    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    k=ucrc16[k];

    tint=0x1F-(magentac16[m-k]);     /* magenta */

    dest|=0x7C1F0000|(tint<<21);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while((size-=2)>-2)
  {
   word=*s++;

   y=0x1F-(word & 0x1F);
   m=0x1F-((word & 0x3E0)>>5);
   c=0x1F-((word & 0x7C00)>>10);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc16[k];

   tint=0x1F-k;     /* black */

   dest=(tint<<10)|(tint<<5)|tint;


   y=0x1F-((word & 0x1F0000)>>16);
   m=0x1F-((word & 0x3E00000)>>21);
   c=0x1F-((word & 0x7C000000)>>26);

   k=MIN(c,m);
   k=MIN(k,y);

   k=blackc16[k];

   tint=0x1F-k;     /* black */

   dest|=(tint<<26)|(tint<<21)|(tint<<16);

   *d++=dest;
  }
 }

 return(NULL);
}









os_error * cscurvergb2cmyk3232(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);
}

/*
os_error * cscurvergb2cmykpal32(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);


}
*/

/*
os_error * cscurvecmyk2rgb32pal(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}
*/

/*
os_error * cscurvergb2cmyk1632(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}
*/
/*
os_error * cscurvecmyk2rgb3216(int * s,int * d,int size)
{


 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}
*/




os_error * cscurvebgr2cmyk3232(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);
}


os_error * cscurvebgr2cmykpal32(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);


}

os_error * cscurvecmyk2bgr32pal(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}

os_error * cscurvebgr2cmyk1632(int * s,int * d,int size)
{

 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}

os_error * cscurvecmyk2bgr3216(int * s,int * d,int size)
{


 USE(s);
 USE(d);
 USE(size);

 return(NULL);

}









int cn;

cscurvestr * cs;


#define CSCHUNK (8*sizeof(cscurvestr))





os_error * cssetcurvex(int n)
{
 os_error * err;
 char       path[FILENAMELEN];
 char     * leaf;

 xzstrncpy(path,colsepbasepath,sizeof(path));
 strcat(path,"\\Colsupp\\Resources\\cmyk\\");
 strcat(path,cs[n].name);
 leaf=path+strlen(path);
 *leaf++='\\';

 strcpy(leaf,"BlackG.dat");
 err=fs_loadblock(path,blackc);
 strcpy(leaf,"Cyan.dat");
 if(!err) err=fs_loadblock(path,cyanc);
 strcpy(leaf,"Yellow.dat");
 if(!err) err=fs_loadblock(path,yellowc);
 strcpy(leaf,"Magenta.dat");
 if(!err) err=fs_loadblock(path,magentac);
 strcpy(leaf,"UnderCR.dat");
 if(!err) err=fs_loadblock(path,ucrc);



#ifdef INVC
 invertcurve(blackic,blackc);
 invertcurve(cyanic,cyanc);
 invertcurve(yellowic,yellowc);
 invertcurve(magentaic,magentac);
#endif


 makecurve16(blackc16,blackc);
 makecurve16(cyanc16,cyanc);
 makecurve16(yellowc16,yellowc);
 makecurve16(magentac16,magentac);
 makecurve16(ucrc16,ucrc);


 return(err);
}





os_error *  csloadcurves(char * path)
{
 os_error * err;
 char       dir[FILENAMELEN];
 fxstat     f;
 int        len1;
 buffer     bf;
 int        eof;


 err=xsprintf(sizeof(dir),NULL,dir,"%s\\Colsupp\\Resources\\cmyk",path);
 len1=strlen(dir);

 if(!err) err=initscan(dir);
 if(!err)
 {
  cn=0;
  err=flex_alloc((flex_ptr)&cs,CSCHUNK);
  if(!err)
  {
   while(nextitem(&f))
   {
    err=xsprintf(sizeof(dir)-len1,NULL,dir+len1,"\\%s\\%s",f.name,"!Contents.txt");
				if(err) break;

    err=flex_chunk((flex_ptr)&cs,(cn+1)*sizeof(cscurvestr),CSCHUNK);
    if(err) break;

    err=bf_open(dir,'r',BUFFMINSIZE,&bf);
    if(err) break;

    xzstrncpy(cs[cn].name,f.name,sizeof(cs[cn].name));
    bf_getstring(&bf,cs[cn].title,sizeof(cs[cn].title)-1,&eof);
    cn++;

/* dprintf(1,"name=%s title=%s",cs[cn-1].name,cs[cn-1].title); */

    bf_close(&bf,err);
   }
  }
  endscan();
  flex_extend((flex_ptr)&cs,cn*sizeof(cscurvestr));

  err=cssetcurvex(0);
 }

 return(err);
}



/* int cscurvename(int n,string & s) */

int cscurvename(int fp)
{
 int      * stack;
 int        n;
 char       temp[256];
 int        s;

 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];

 if(n>=0 && n<cn)
 {
  xzstrncpy(temp,cs[n].title,sizeof(temp));
  assignstring(s,temp);
  return(1);
 }
 return(0);
}



int csfindcurvename(char * string)
{
 int n;

 for(n=0;n<cn;n++)
 {
  if(!cstrcmp(string,cs[n].title)) return(n);
 }
 return(-1);
}


