/*->c.csprint */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"


#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "font.h"
#include "timex.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"



#include "view.h"
#include "file.h"

#include "dbscale.h"

#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"
#include "units.h"
#include "macros.h"
#include "xredraw.h"
#include "xrender.h"
#include "curve.h"


#include "prstr.h"

#include "codes.h"


#include "colsep.h"
#include "colseplink.h"



#include "csstr.h"
#include "colsepx.h"
#include "colcode.h"
#include "csink.h"
#include "cscurve.h"
#include "csnaive.h"
#include "csprocess.h"
#include "xpr.h"
#include "csview.h"


#include "csprint.h"



#define CSMAXFONTLEN 48


static char cstextfont[CSMAXFONTLEN]="Courier New";

static int cstextx1;
static int cstextx2;
static int cstexty;
static int cstextsize;


static int csbarx;
static int csbary;
static int csbarwidth;
static int csbarheight;





static TCHAR   * exstring;
static int       exlength;
static filestr * exfile;
static psetstr * expset;



static os_error * expfn(int c)
{
 pagestr     * pagep;
 sectionstr  * sectionp;
 int           ch;

// cprintf("expfn %d",c);

 *exstring=0;

 switch(c)
 {
   case      XPAGENO:
                     pagep=(pagestr*)fob_find(expset->page,exfile);
                     sprintf(exstring,"%d",pagep->data.number);
                     break;

   case      XCHAPNO:
                     sectionp=(sectionstr*)fob_find(expset->section,exfile);
                     sprintf(exstring,"%d",sectionp->data.number);
                     break;

   case        XDATE:
                     writesysdate(exstring);
                     break;

   case        XTIME:
                     writesystime(exstring);
                     break;

   case    XDATETIME:
                     writesystimedate(exstring);
                     break;


   case     XDOCNAME:
                     strcpy(exstring,fs_leaf(exfile->name));
                     break;

   case     XDOCPATH:
                     strcpy(exstring,exfile->name);
                     break;

   case      XDOCDIR:
                     fs_path(exfile->name,exstring,exlength);
                     break;

             default:
                     ch=-1;

                     if(c>255)
                     {
                      ch=code16inv(c);
                     }
                     else
                     {
 	                    ch=code8symbolinv(c);

                      if(ch<0)
                      {
                       c=code16win(c);
                      }
                     }

                     if(ch>=0)
                     {
                      exstring[0]=ch;
                      exstring[1]=0;
                     }
                     break;

 }

 exstring+=strlen(exstring);
 exlength-=strlen(exstring);

// cprintf("exstring %s",exstring);

 return(NULL);
}


/* KKYYMMCC */


static int cmykcoltab[7][3]=
{
 0xFF000000, 0x7F000000, 0x19000000,  /* K  */
 0x00FF00FF, 0x007F007F, 0x00190019,  /* CY */
 0x000000FF, 0x0000007F, 0x00000019,  /* C  */
 0x0000FFFF, 0x00007F7F, 0x00001919,  /* MC */
 0x0000FF00, 0x00007F00, 0x00001900,  /* M  */
 0x00FFFF00, 0x007F7F00, 0x00191900,  /* MY */
 0x00FF0000, 0x007F0000, 0x00190000,  /* Y  */
};



static os_error * markevent(int eventn,int userhandle,
                                       viewstr * view,viewredrawstr * v)
{
 paperstr        * p;
 int               ox;
 int               oy;
 char              string[1024];
 char              temp[SEPTEXTLEN];
 int               x;
 int               y;
// os_regset         rx;
 colourstr       * cs;
 filestr         * file;
 colsepobjectstr * csp;
 int               rgb32;
 int               i;
 int               j;
 prjobstr        * prjob;


// cprintf("markevent %x",view->process);

 prjob=(prjobstr*)v->prjob;


 if(prjob->doseparations)
 {
  p=PRJOBPP(prjob,prjob->pn);

  ox=osunits(p->cbox.x0,view);   // was bosunits
  oy=osunits(p->cbox.y1,view);

  exfile=file=view->file;
  expset=p->pset;

  findcoloursp(currentcolour,&cs,file);
  xzstrncpy(string,cs->name,sizeof(string));

  x=cstextx1;
  y=-cstexty;

  render_string(cstextfont,cstextsize,cstextsize,0,
                string,font_ABS|font_OSCOORDS,ox+osunits(x,view),oy-osunits(y,view),v);


  if(file->hdr.colsep)
  {
   csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);

   if(csp->data.hdr.doseptext)
   {
    xzstrncpy(temp,csp->data.hdr.septext,sizeof(temp));
    exstring=string;
				exlength=NITEM(string);
    expandmacro(expfn,temp);

    x=cstextx2;

    render_string(cstextfont,cstextsize,cstextsize,0,
                  string,font_ABS|font_OSCOORDS,ox+osunits(x,view),oy-osunits(y,view),v);
   }
  }


  if(!currentspot)
  {
   pathstyle style;
   int       path[35];
   curvestr  c;

   memset(&style,0,sizeof(pathstyle));

   
   x=csbarx;
   y=csbary+(p->cbox.y1-p->cbox.y0);


   for(i=0;i<7;i++)
   {
    for(j=0;j<3;j++)
    {
     ((processfn3)view->process)((int)view,&rgb32,&cmykcoltab[i][j],
                                              1,PROCESST_RGB32,PROCESST_CMYK,NULL,NULL);
     rgb32=rgb32<<8;

     render_setgcol(rgb32,0,v);

     c.type=CBOX;
     c.box.x=x;
     c.box.w=csbarwidth;
     c.box.y=y;
     c.box.h=csbarheight;

     style.action=0x2;

     curvepath(&c,path);

     rpathline(path,&style,v,NULL);

     x+=csbarwidth;
    }
   }
  }
 }

 return(NULL);

 USE(eventn);
 USE(userhandle);
}



/* void cschoices2(int cstextx1,int cstextx2,int cstexty,
                                     int cstextsize,string & cstextfont); */

void cschoices2(int fp)
{
 int     * stack;

 stack=xstackptr();

 cstextx1=stack[fp];
 cstextx2=stack[fp+1];
 cstexty=stack[fp+2];
 cstextsize=stack[fp+3];
 xzstrncpy(cstextfont,stringptr(stack[fp+4]),sizeof(cstextfont));
}



/* void cschoices3(int csbarx,int csbary,int csbarwidth,int csbarheight); */

void cschoices3(int fp)
{
 int     * stack;

 stack=xstackptr();

 csbarx=stack[fp];
 csbary=stack[fp+1];
 csbarwidth=stack[fp+2];
 csbarheight=stack[fp+3];
}




os_error * csprintchoices(buffer * bf)
{
 os_error * err;

          err=bf_printfeol(bf,"cschoices2(%d,%d,%d,%d,\"%s\");",
                   cstextx1,cstextx2,cstexty,cstextsize,cstextfont);

 if(!err) err=bf_printfeol(bf,"cschoices3(%d,%d,%d,%d);",
                   csbarx,csbary,csbarwidth,csbarheight);

 return(err);
}





os_error * csprintinit(void)
{
 return(addevent(EVENT_PRMARKS,(eventfn)markevent,0));
}


