/*->c.cssp */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "osprint.h"
#include "deb.h"



#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "constants.h"


#include "prstr.h"
#include "xprint.h"



#include "splink.h"



#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "colsep.h"
#include "colseplink.h"




#include "csview.h"

#include "cssp.h"



#ifdef NEVER


static void fillblack32(int * d,int n)
{
 memset(d,0,n*sizeof(int));
}



static void fillwhite32(int * d,int n)
{
 while(n--)
 {
  *d++=0xFFFFFF;
 }
}




static void fillblack16(int * d,int n)
{
 memset(d,0,n*(sizeof(int)/2));
}



static void fillwhite16(int * d,int n)
{
 int n1;

 n1=n/2;

 while(n1--)
 {
  *d++=0x7FFF7FFF;
 }

 if(n & 0x1)
 {
  *((char*)d)=0xFF;
  *(((char*)d)+1)=0x7F;
 }
}






static os_error   * csrenderrgb16(newsprite_header * sp,transformstr * tr,
                                                       processstr * pr)
{
 os_error         * err;
 int                xpix;
 int                ypix;
 int                size;
 int                rypix;
 newsprite_header * sp2;
 int                y;
 sprite_id          id;
 coordstr           cx[4];
 int                y2;
 int              * s;
 int              * d;
 int              * sm;
 int              * dm;
 int                sypix;
// char               pixtrans[1024];
 int                maskx;
 int                wordx;
	int                xdpi;
	int                ydpi;


 err=NULL;

 wordx=sp->width+1;
 xpix=(32*wordx-(31-sp->rbit))/16;

 rypix=ypix=sp->height+1;

 if(sp->image!=sp->mask)
 {
  maskx=(xpix+31)&(~31);
  maskx/=32;
 }
 else maskx=0;


 while(1)
 {
  size=sizeof(newsprite_header)+(wordx+maskx)*rypix*sizeof(int);

  err=flex_alloc((flex_ptr)&sp2,size);
  if(!err) break;

  rypix=(rypix+1)/2;
  if(rypix<2) break;
 }



 if(!err)
 {
  *sp2=*sp;
		xdpi=sp2->selector.type.xdpi;
		ydpi=sp2->selector.type.ydpi;


  for(y=0;y<ypix;y+=rypix)
  {
   sypix=MIN(rypix,(ypix-y));
   sp2->height=sypix-1;
   sp2->next=sizeof(newsprite_header)+(wordx+maskx)*sizeof(int)*sypix;
   sp2->image=sizeof(newsprite_header);

   if(maskx) sp2->mask=sizeof(newsprite_header)+wordx*sizeof(int)*sypix;
   else      sp2->mask=sp2->image;


   s=(int*)(((char*)sp)+sp->image+(ypix-y-rypix)*wordx*sizeof(int));
   d=(int*)(((char*)sp2)+sp2->image);
   sm=(int*)(((char*)sp)+sp->mask+(ypix-y-rypix)*maskx*sizeof(int));
   dm=(int*)(((char*)sp2)+sp2->mask);

   for(y2=0;y2<sypix;y2++)  /* can be made much simpler x*y pix */
   {
    if(pr->mode==PROCESSBLACK) fillblack16(d,xpix);
    else
    if(pr->mode==PROCESSWHITE) fillwhite16(d,xpix);
    else
    if(pr->mode==PROCESSFN)
    {
     pr->process(pr->handle,d,s,xpix,PROCESST_RGB16,PROCESST_RGB16);
    }

    s+=wordx;
    d+=wordx;

    if(maskx)
    {
     XMEMCPYX(dm,sm,maskx*sizeof(int));
     dm+=maskx;
     sm+=maskx;
    }
   }


   id.tag=sprite_id_addr;
   id.s.addr=sp2;


   cx[0].x=0;               /* left,top */
   cx[0].y=scale((y+sypix),180*256,ydpi);


   cx[1].x=scale(xpix,180*256,xdpi);      /* right,top */
   cx[1].y=cx[0].y;


   cx[2].x=cx[1].x;                      /* right,bot */
   cx[2].y=scale(y,180*256,ydpi);


   cx[3].x=0;               /* left,bot */
   cx[3].y=cx[2].y;


   if(pr->isprinter)
   {
    if((getprintbits() & PRB_INV56) && !pr->tosprite)
    {
     SWOP(cx[0].y,cx[2].y);
     SWOP(cx[1].y,cx[3].y);
    }
   }


   tr_transformset(cx,4,tr);

//   err=selectsptable((sprite_header*)sp2,pixtrans,(pr->spritebits & (1<<5))?1024:256);

   if(!err) err=sprite_put_trans((sprite_area *)0xFF,&id,
                                 8|(1<<8)|pr->spritebits,
                         (sprite_transform*)cx,NULL /*(sprite_pixtrans*)pixtrans*/);
  }

  flex_free((flex_ptr)&sp2);
 }


 return(err);
}









static os_error   * csrenderrgb32(newsprite_header * sp,transformstr * tr,
                                                        processstr * pr)
{
 os_error         * err;
 int                xpix;
 int                ypix;
 int                size;
 int                rypix;
 newsprite_header * sp2;
 int                y;
 sprite_id          id;
 coordstr           cx[4];
 int                y2;
 int              * s;
 int              * d;
 int              * sm;
 int              * dm;
 int                sypix;
// char               pixtrans[1024];
 int                maskx;
	int                xdpi;
	int                ydpi;


 err=NULL;

 xpix=sp->width+1;
 rypix=ypix=sp->height+1;

 if(sp->image!=sp->mask)
 {
  maskx=(xpix+31)&(~31);
  maskx/=32;
 }
 else maskx=0;


 while(1)
 {
  size=sizeof(newsprite_header)+(xpix+maskx)*rypix*sizeof(int);

  err=flex_alloc((flex_ptr)&sp2,size);
  if(!err) break;

  rypix=(rypix+1)/2;
  if(rypix<2) break;
 }



 if(!err)
 {
  *sp2=*sp;
			xdpi=sp2->selector.type.xdpi;
			ydpi=sp2->selector.type.ydpi;


  for(y=0;y<ypix;y+=rypix)
  {
   sypix=MIN(rypix,(ypix-y));
   sp2->height=sypix-1;
   sp2->next=sizeof(newsprite_header)+(xpix+maskx)*sizeof(int)*sypix;
   sp2->image=sizeof(newsprite_header);


   if(maskx) sp2->mask=sizeof(newsprite_header)+xpix*sizeof(int)*sypix;
   else      sp2->mask=sp2->image;


   s=(int*)(((char*)sp)+sp->image+(ypix-y-rypix)*xpix*sizeof(int));
   d=(int*)(((char*)sp2)+sp2->image);
   sm=(int*)(((char*)sp)+sp->mask+(ypix-y-rypix)*maskx*sizeof(int));
   dm=(int*)(((char*)sp2)+sp2->mask);

   for(y2=0;y2<sypix;y2++)  /* can be made much simpler x*y pix */
   {
    if(pr->mode==PROCESSBLACK) fillblack32(d,xpix);
    else
    if(pr->mode==PROCESSWHITE) fillwhite32(d,xpix);
    else
    if(pr->mode==PROCESSFN)
    {
     pr->process(pr->handle,d,s,xpix,PROCESST_RGB32,PROCESST_RGB32);
    }

    s+=xpix;
    d+=xpix;

    if(maskx)
    {
     XMEMCPYX(dm,sm,maskx*sizeof(int));
     dm+=maskx;
     sm+=maskx;
    }
   }


   id.tag=sprite_id_addr;
   id.s.addr=sp2;


   cx[0].x=0;               /* left,top */
   cx[0].y=scale((y+sypix),180*256,ydpi);


   cx[1].x=scale(xpix,180*256,xdpi);      /* right,top */
   cx[1].y=cx[0].y;


   cx[2].x=cx[1].x;                      /* right,bot */
   cx[2].y=scale(y,180*256,ydpi);


   cx[3].x=0;               /* left,bot */
   cx[3].y=cx[2].y;

   if(pr->isprinter)
   {
    if((getprintbits() & PRB_INV56) && !pr->tosprite)
    {
     SWOP(cx[0].y,cx[2].y);
     SWOP(cx[1].y,cx[3].y);
    }
   }

   tr_transformset(cx,4,tr);


//   err=selectsptable((sprite_header*)sp2,pixtrans,(pr->spritebits & (1<<5))?1024:256);


   if(!err) err=sprite_put_trans((sprite_area *)0xFF,&id,
                                 8|(1<<8)|pr->spritebits,
                        (sprite_transform*)cx,NULL /*(sprite_pixtrans*)pixtrans*/);
  
  }

  flex_free((flex_ptr)&sp2);
 }


 return(err);
}








static os_error * csrendercmyk(newsprite_header * sp,transformstr * tr,
                                                       processstr * pr)
{
 os_error         * err;
 int                xpix;
 int                ypix;
 int                size;
 int                rypix;
 newsprite_header * sp2;
 int                y;
 sprite_id          id;
 coordstr           cx[4];
 int                y2;
 int              * s;
 int              * d;
 int              * sm;
 int              * dm;
 int                sypix;
// char               pixtrans[1024];
 int                maskx;
	int                xdpi;
	int                ydpi;


 err=NULL;

 xpix=sp->width+1;
 rypix=ypix=sp->height+1;

 if(sp->image!=sp->mask)
 {
  maskx=(xpix+31)&(~31);
  maskx/=32;
 }
 else maskx=0;


 while(1)
 {
  size=sizeof(newsprite_header)+(xpix+maskx)*rypix*sizeof(int);

  err=flex_alloc((flex_ptr)&sp2,size);
  if(!err) break;

  rypix=(rypix+1)/2;
  if(rypix<2) break;
 }



 if(!err)
 {
  *sp2=*sp;
		xdpi=sp2->selector.type.xdpi;
		ydpi=sp2->selector.type.ydpi;


  for(y=0;y<ypix;y+=rypix)
  {
   sypix=MIN(rypix,(ypix-y));
   sp2->height=sypix-1;
   sp2->next=sizeof(newsprite_header)+(xpix+maskx)*sizeof(int)*sypix;
   sp2->image=sizeof(newsprite_header);

   if(maskx) sp2->mask=sizeof(newsprite_header)+xpix*sizeof(int)*sypix;
   else      sp2->mask=sp2->image;

   sp2->selector.type.type=6;


   s=(int*)(((char*)sp)+sp->image+(ypix-y-rypix)*xpix*sizeof(int));
   d=(int*)(((char*)sp2)+sp2->image);
   sm=(int*)(((char*)sp)+sp->mask+(ypix-y-rypix)*maskx*sizeof(int));
   dm=(int*)(((char*)sp2)+sp2->mask);

   for(y2=0;y2<sypix;y2++)  /* can be made much simpler x*y pix */
   {
    if(pr->mode==PROCESSBLACK) fillblack32(d,xpix);
    else
    if(pr->mode==PROCESSWHITE) fillwhite32(d,xpix);
    else
    if(pr->mode==PROCESSNONE) colsepcmyk2rgb3232(s,d,xpix);
    else
    if(pr->mode==PROCESSFN) pr->process(pr->handle,d,s,xpix,PROCESST_RGB32,
                                                            PROCESST_CMYK);

    s+=xpix;
    d+=xpix;

    if(maskx)
    {
     XMEMCPYX(dm,sm,maskx*sizeof(int));
     dm+=maskx;
     sm+=maskx;
    }
   }


   id.tag=sprite_id_addr;
   id.s.addr=sp2;


   cx[0].x=0;               /* left,top */
   cx[0].y=scale((y+sypix),180*256,ydpi);


   cx[1].x=scale(xpix,180*256,xdpi);      /* right,top */
   cx[1].y=cx[0].y;


   cx[2].x=cx[1].x;                      /* right,bot */
   cx[2].y=scale(y,180*256,ydpi);


   cx[3].x=0;               /* left,bot */
   cx[3].y=cx[2].y;


   if(pr->isprinter)
   {
    if((getprintbits() & PRB_INV56) && !pr->tosprite)
    {
     SWOP(cx[0].y,cx[2].y);
     SWOP(cx[1].y,cx[3].y);
    }
   }

   tr_transformset(cx,4,tr);


//   err=selectsptable((sprite_header*)sp2,pixtrans,(pr->spritebits & (1<<5))?1024:256);

   if(!err) err=sprite_put_trans((sprite_area *)0xFF,&id,
                                 8|(1<<8)|pr->spritebits,
                        (sprite_transform*)cx,NULL /*(sprite_pixtrans*)pixtrans*/);

  }

  flex_free((flex_ptr)&sp2);
 }


 return(err);
}


#endif


static os_error * csrender(newsprite_header * sp,transformstr * tr,
                           processstr  * pr,int * claimed)
{
 os_error * err;
 int        type;


 err=NULL;

//	cprintf("csrender %d %d %d",pr->prjob,(((prjobstr*)pr->prjob)->prtype==PRPS),(((prjobstr*)pr->prjob)->bits & PSDIRECT));

 if(
    pr->prjob && (((prjobstr*)pr->prjob)->prtype==PRPS) && (((prjobstr*)pr->prjob)->bits & PSDIRECT)
			)
	{
		// do nothing
	}
	else
	{
  if(((newsprite_header*)sp)->selector.type.type!=0)
  {
   type=((newsprite_header*)sp)->selector.type.type;

 /*
   Believe setprocess() is called first...
   cscolourmodel=pr->isprinter?csprintercolourmodel:csscreencolourmodel;
 */

   if(type==7)
   {
//    err=csrendercmyk((newsprite_header*)sp,tr,pr);
//    *claimed=1;
   }
   else
   if(type==6 && pr->mode!=PROCESSNONE)
   {
//    err=csrenderrgb32((newsprite_header*)sp,tr,pr);
//    *claimed=1;
   }
   else
   if(type==5 && pr->mode!=PROCESSNONE)
   {
//    err=csrenderrgb16((newsprite_header*)sp,tr,pr);
//    *claimed=1;
   }
  }
	}

 return(err);
}





static splinkblockstr splink=
{
 csrender,
 NULL,

};



os_error * csspinit(void)
{
 return(sp_addblock(&splink));
}



