/*->c.fillcol */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"


#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"
#include "colseplink.h"



#include "xredraw.h"
#include "curve.h"

#include "filllink.h"
#include "fillstub.h"


#include "fillcol.h"


#define MAXTINT2 (MAXTINT>>2)



os_error * filltableinit(colourvalue * start,colourvalue * end,
                         viewstr * view,int * doproc,int * table,int flags,int * xmodel)
{
 filestr         * file;
 int               rs;
 int               gs;
 int               bs;
 int               ks;
 int               re;
 int               ge;
 int               be;
 int               ke;
 int               i;
 colourstr       * cs;
 quadstr           q;
 quadstr           s;
 int               tint;
 int               r;
 int               g;
 int               b;
 int               k;
 int               rw;
 int               gw;
 int               bw;
 int               kw;
 int               rh;
 int               gh;
 int               bh;
 int               kh;
 int               rr;
 int               gr;
 int               br;
 int               kr;
 int               dr;
 int               dg;
 int               db;
 int               dk;
 int               model;
 int               spotmode;
 int               skips;
 int               skipe;
 int               key;


 file=view->file;


 csgetspotinfo(view,&key,&spotmode);

 model=RGBMODEL; /* compiler */


 findcoloursp(start->data.tint.key,&cs,file);

 skips=(key && (int)start->data.tint.key!=key &&
        (!(cs->flags & COLOURALLPLATES)) &&
        ((cs->flags & (COLOURPLATE|COLOURTRANS)) || spotmode));

 tint=start->data.tint.tint>>2;

 if(spotmode)
 {
  if(skips) rs=gs=bs=ks=MAXCV;
  else      rs=gs=bs=ks=((MAXTINT2-tint)*MAXCV)/MAXTINT2;
 }
 else
 {
  if(cs->model.no==HSVMODEL)
  {
   s=cs->model.data.quad;
   model=RGBMODEL;
   xcconv(view,file,&s,cs->model.no,&q,model);
  }
  else
  {
   q=cs->model.data.quad;
   model=cs->model.no;
  }

  if(model==RGBMODEL)
  {
   if(skips) rs=gs=bs=ks=MAXCV;
   else
   {
    rs=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.r)/MAXTINT2;
    gs=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.g)/MAXTINT2;
    bs=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.b)/MAXTINT2;
    ks=((MAXTINT2-tint)*MAXCV+tint*q.type.cmyk.k)/MAXTINT2;
   }
  }
  else
  {
   if(skips) rs=gs=bs=ks=0;
   else
   {
    rs=(tint*q.type.cmyk.c)/MAXTINT2;
    gs=(tint*q.type.cmyk.m)/MAXTINT2;
    bs=(tint*q.type.cmyk.y)/MAXTINT2;
    ks=(tint*q.type.cmyk.k)/MAXTINT2;
   }
  }
 }

 findcoloursp(end->data.tint.key,&cs,file);

 skipe=(key && (int)end->data.tint.key!=key && 
        (!(cs->flags & COLOURALLPLATES)) &&
        ((cs->flags & (COLOURPLATE|COLOURTRANS)) || spotmode));

 tint=end->data.tint.tint>>2;

 if(spotmode)
 {
  if(skipe) re=ge=be=ke=MAXCV;
  else      re=ge=be=ke=((MAXTINT2-tint)*MAXCV)/MAXTINT2;
 }
 else
 {
  if(cs->model.no!=model)
  {
   s=cs->model.data.quad;
   xcconv(view,file,&s,cs->model.no,&q,model);
  }
  else
  {
   q=cs->model.data.quad;
  }


  if(model==RGBMODEL)
  {
   if(skipe) re=ge=be=ke=MAXCV;
   else
   {
    re=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.r)/MAXTINT2;
    ge=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.g)/MAXTINT2;
    be=((MAXTINT2-tint)*MAXCV+tint*q.type.rgb.b)/MAXTINT2;
    ke=((MAXTINT2-tint)*MAXCV+tint*q.type.cmyk.k)/MAXTINT2;
   }
  }
  else
  {
   if(skipe) re=ge=be=ke=0;
   else
   {
    re=(tint*q.type.cmyk.c)/MAXTINT2;
    ge=(tint*q.type.cmyk.m)/MAXTINT2;
    be=(tint*q.type.cmyk.y)/MAXTINT2;
    ke=(tint*q.type.cmyk.k)/MAXTINT2;
   }
  }
 }

/*
 if(key==KEYMAGENTA)
 {
  dprintf(2,"spotmode=%d skps=%d skpe=%d model=%d",spotmode,skips,skipe,model);
  dprintf(3,"rs=%x re=%x gs=%x ge=%x bs=%x be=%x ks=%x ke=%x",
             rs,re,gs,ge,bs,be,ks,ke);
 }
*/

/*

 if(skips && skipe) *doproc=FILLTABLENULL;
 else

 DP 314

 A graduated fill between two colours which don't appear on a spot plate
 (which is being viewed).
 Firstly in fillobject a sprite has been set up based on this fill declaring
 itself solid. There is no way of skipping getting out of plotting
 this sprite.
 Second for printing it makes sense to knock out the area.


*/

 {
  *doproc=0;

  rh=re-rs;
  gh=ge-gs;
  bh=be-bs;
  kh=ke-ks;


  if(rh<0) {rh=-rh;dr=-1;}
  else     {dr=1;}

  if(gh<0) {gh=-gh;dg=-1;}
  else     {dg=1;}

  if(bh<0) {bh=-bh;db=-1;}
  else     {db=1;}

  if(kh<0) {kh=-kh;dk=-1;}
  else     {dk=1;}


  rw=0x10000;
  gw=0x10000;
  bw=0x10000;
  kw=0x10000;

  rr=rh/2;
  gr=gh/2;
  br=bh/2;
  kr=kh/2;


  r=(rs*256)/MAXCV;
  if(r>255) r=255;
  g=(gs*256)/MAXCV;
  if(g>255) g=255;
  b=(bs*256)/MAXCV;
  if(b>255) b=255;

  k=(ks*256)/MAXCV;
  if(k>255) k=255;


  for(i=0;i<256;i++)
  {
   rr+=rh;
   while(rr>=rw)
   {
    r+=dr;
    if(r>255) r=255;
    if(r<0)   r=0;
    rr-=rw;
   }

   gr+=gh;
   while(gr>=gw)
   {
    g+=dg;
    if(g>255) g=255;
    if(g<0)   g=0;
    gr-=gw;
   }

   br+=bh;
   while(br>=bw)
   {
    b+=db;
    if(b>255) b=255;
    if(b<0)   b=0;
    br-=bw;
   }

   kr+=kh;
   while(kr>=kw)
   {
    k+=dk;
    if(k>255) k=255;
    if(k<0)   k=0;
    kr-=kw;
   }

   table[i]=(k<<24)|(b<<16)|(g<<8)|(r);
  }



  if(spotmode)
		{
			// can't process spot colours

			model=GREYMODEL;
		}
		else
  {
   if(view->process)		// assume this means seps
   {
    if(model==CMYKMODEL)
    {
     ((processfn3)view->process)((int)view,table,table,256,
                                          PROCESST_RGB32,PROCESST_CMYK,NULL,NULL);
     model=RGBMODEL;
    }
    else
    {
     ((processfn3)view->process)((int)view,table,table,256,
                                          PROCESST_RGB32,PROCESST_RGB32,NULL,NULL);
    }
   }
   else
   {
    if(model==CMYKMODEL && !(flags & FILLTABLECMYK))
    {
     xcmyk2rgb3232(view,table,table,256);
    }
   }
  }

		if(xmodel) *xmodel=model;
 }

 return(NULL);
}







